Index: vl.c
===================================================================
--- vl.c	(revision 4734)
+++ vl.c	(working copy)
@@ -7732,47 +8797,83 @@
         }
     }
 #endif
+#ifdef _WIN32
+    /* compute the bios directory by using the executable dir */
+    {
+        static char exe_path[1024];
+        char *p;
 
+        GetModuleFileNameA(NULL, exe_path, sizeof(exe_path));
+        p = strrchr(exe_path, '\\');
+        if (p)
+            *p = '\0';
+        bios_dir = exe_path;
+    }
+#endif
+    
     register_machines();
-    machine = first_machine;
-    cpu_model = NULL;
-    initrd_filename = NULL;
-    ram_size = 0;
+    init_classes();
+    qemu_prefs = qemu_device_new(qemu_class_find("preferences"), "prefs");
+    qemu_prefs->instantiated = 1;
+
+    /* XXX: reuse generic option parser, this parser is buggy */
+    prefs_filename = NULL;
+    for(optind = 1; optind < (argc - 1); optind++) {
+        if (!strcmp(argv[optind], "-f") || !strcmp(argv[optind], "--f")) {
+            optind++;
+            prefs_filename = argv[optind];
+        }
+    }
+    /* read user preference file */
+    if (prefs_filename) {
+        if (qemu_parse_config(&qemu_prefs, prefs_filename, 
+                              QEMU_CONF_NO_OBJ | QEMU_CONF_ERR_FILE) < 0)
+            exit(1);
+    } else {
+#ifdef _WIN32
+        {
+            char buf[1024];
+            snprintf(buf, sizeof(buf), "%s/config", bios_dir);
+            if (qemu_parse_config(&qemu_prefs, buf, QEMU_CONF_NO_OBJ) == -1)
+                exit(1);
+        }
+#else
+        {   
+            char buf[1024];
+            const char *home_path;
+            home_path = getenv("HOME");
+            if (!home_path)
+                home_path = "";
+            snprintf(buf, sizeof(buf), "%s/.qemu/config", home_path);
+            if (qemu_parse_config(&qemu_prefs, buf, QEMU_CONF_NO_OBJ) == -1)
+                exit(1);
+        }
+#endif
+    }
+    
+    /* Note: unlike other devices, we may change the type of this
+       device later */
+    machine_dev = qemu_device_new(qemu_class_find(first_machine->name), "hw0");
     vga_ram_size = VGA_RAM_SIZE;
 #ifdef CONFIG_GDBSTUB
     use_gdbstub = 0;
     gdbstub_port = DEFAULT_GDBSTUB_PORT;
 #endif
-    snapshot = 0;
     nographic = 0;
-    curses = 0;
-    kernel_filename = NULL;
-    kernel_cmdline = "";
     cyls = heads = secs = 0;
     translation = BIOS_ATA_TRANSLATION_AUTO;
-    monitor_device = "vc:800x600";
 
-    serial_devices[0] = "vc:80Cx24C";
-    for(i = 1; i < MAX_SERIAL_PORTS; i++)
-        serial_devices[i] = NULL;
     serial_device_index = 0;
-
-    parallel_devices[0] = "vc:640x480";
-    for(i = 1; i < MAX_PARALLEL_PORTS; i++)
-        parallel_devices[i] = NULL;
     parallel_device_index = 0;
 
-    usb_devices_index = 0;
-
     nb_net_clients = 0;
     nb_drives = 0;
     nb_drives_opt = 0;
     hda_index = -1;
 
-    nb_nics = 0;
+    has_config = 0;
+    do_dump_devices = 0;
 
-    tb_size = 0;
-    
     optind = 1;
     for(;;) {
         if (optind >= argc)
@@ -7811,16 +8912,21 @@
 
             switch(popt->index) {
             case QEMU_OPTION_M:
-                machine = find_machine(optarg);
-                if (!machine) {
-                    QEMUMachine *m;
-                    printf("Supported machines are:\n");
-                    for(m = first_machine; m != NULL; m = m->next) {
-                        printf("%-10s %s%s\n",
-                               m->name, m->desc,
-                               m == first_machine ? " (default)" : "");
+                {
+                    QEMUMachine *m, *machine;
+                    machine = find_machine(optarg);
+                    if (!machine) {
+                        printf("Supported machines are:\n");
+                        for(m = first_machine; m != NULL; m = m->next) {
+                            printf("%-10s %s%s\n",
+                                   m->name, m->desc,
+                                   m == first_machine ? " (default)" : "");
+                        }
+                        exit(*optarg != '?');
                     }
-                    exit(*optarg != '?');
+                    qemu_device_delete(machine_dev);
+                    machine_dev = qemu_device_new(qemu_class_find(machine->name), 
+                                                  "hw0");
                 }
                 break;
             case QEMU_OPTION_cpu:
@@ -7832,11 +8938,11 @@
 #endif
                     exit(0);
                 } else {
-                    cpu_model = optarg;
+                    qemu_device_set_str(machine_dev, "cpu", optarg);
                 }
                 break;
             case QEMU_OPTION_initrd:
-                initrd_filename = optarg;
+                qemu_device_set_str(machine_dev, "initrd", optarg);
                 break;
             case QEMU_OPTION_hda:
                 if (cyls == 0)
@@ -7868,7 +8974,7 @@
                 drive_add(optarg, PFLASH_ALIAS);
                 break;
             case QEMU_OPTION_snapshot:
-                snapshot = 1;
+                qemu_device_set_bool(machine_dev, "snapshot", 1);
                 break;
             case QEMU_OPTION_hdachs:
                 {
@@ -7916,58 +9022,27 @@
                 }
                 break;
             case QEMU_OPTION_nographic:
-                serial_devices[0] = "stdio";
-                parallel_devices[0] = "null";
-                monitor_device = "stdio";
-                nographic = 1;
+                qemu_device_set_str(qemu_prefs, "ui", "cmdline");
                 break;
 #ifdef CONFIG_CURSES
             case QEMU_OPTION_curses:
-                curses = 1;
+                qemu_device_set_str(qemu_prefs, "ui", "curses");
                 break;
 #endif
             case QEMU_OPTION_portrait:
-                graphic_rotate = 1;
+                qemu_device_set_bool(machine_dev, "portrait", 1);
                 break;
             case QEMU_OPTION_kernel:
-                kernel_filename = optarg;
+                qemu_device_set_str(machine_dev, "kernel", optarg);
                 break;
             case QEMU_OPTION_append:
-                kernel_cmdline = optarg;
+                qemu_device_set_str(machine_dev, "append", optarg);
                 break;
             case QEMU_OPTION_cdrom:
                 drive_add(optarg, CDROM_ALIAS);
                 break;
             case QEMU_OPTION_boot:
-                boot_devices = optarg;
-                /* We just do some generic consistency checks */
-                {
-                    /* Could easily be extended to 64 devices if needed */
-                    const char *p;
-                    
-                    boot_devices_bitmap = 0;
-                    for (p = boot_devices; *p != '\0'; p++) {
-                        /* Allowed boot devices are:
-                         * a b     : floppy disk drives
-                         * c ... f : IDE disk drives
-                         * g ... m : machine implementation dependant drives
-                         * n ... p : network devices
-                         * It's up to each machine implementation to check
-                         * if the given boot devices match the actual hardware
-                         * implementation and firmware features.
-                         */
-                        if (*p < 'a' || *p > 'q') {
-                            fprintf(stderr, "Invalid boot device '%c'\n", *p);
-                            exit(1);
-                        }
-                        if (boot_devices_bitmap & (1 << (*p - 'a'))) {
-                            fprintf(stderr,
-                                    "Boot device '%c' was given twice\n",*p);
-                            exit(1);
-                        }
-                        boot_devices_bitmap |= 1 << (*p - 'a');
-                    }
-                }
+                qemu_device_set_str(machine_dev, "boot", optarg);
                 break;
             case QEMU_OPTION_fda:
             case QEMU_OPTION_fdb:
@@ -7975,31 +9050,31 @@
                 break;
 #ifdef TARGET_I386
             case QEMU_OPTION_no_fd_bootchk:
-                fd_bootchk = 0;
+                qemu_device_set_bool(machine_dev, "fd_bootchk", 0);
                 break;
 #endif
             case QEMU_OPTION_net:
-                if (nb_net_clients >= MAX_NET_CLIENTS) {
-                    fprintf(stderr, "qemu: too many network clients\n");
-                    exit(1);
-                }
-                net_clients[nb_net_clients] = optarg;
+                net_add(optarg);
                 nb_net_clients++;
                 break;
 #ifdef CONFIG_SLIRP
             case QEMU_OPTION_tftp:
-		tftp_prefix = optarg;
+		slirp_tftp_prefix = optarg;
                 break;
             case QEMU_OPTION_bootp:
-                bootp_filename = optarg;
+                slirp_bootp_filename = optarg;
                 break;
 #ifndef _WIN32
             case QEMU_OPTION_smb:
-		net_slirp_smb(optarg);
+		slirp_smb_path = optarg;
                 break;
 #endif
             case QEMU_OPTION_redir:
-                net_slirp_redir(optarg);
+                if (nb_slirp_redirs >= SLIRP_MAX_REDIRS) {
+                    fprintf(stderr, "Too many slirp redirections\n");
+                    exit(1);
+                }
+                slirp_redirs[nb_slirp_redirs++] = optarg;
                 break;
 #endif
 #ifdef HAS_AUDIO
@@ -8014,55 +9089,28 @@
             case QEMU_OPTION_h:
                 help(0);
                 break;
-            case QEMU_OPTION_m: {
-                uint64_t value;
-                char *ptr;
-
-                value = strtoul(optarg, &ptr, 10);
-                switch (*ptr) {
-                case 0: case 'M': case 'm':
-                    value <<= 20;
-                    break;
-                case 'G': case 'g':
-                    value <<= 30;
-                    break;
-                default:
-                    fprintf(stderr, "qemu: invalid ram size: %s\n", optarg);
-                    exit(1);
-                }
-
-                /* On 32-bit hosts, QEMU is limited by virtual address space */
-                if (value > (2047 << 20)
-#ifndef USE_KQEMU
-                    && HOST_LONG_BITS == 32
-#endif
-                    ) {
-                    fprintf(stderr, "qemu: at most 2047 MB RAM can be simulated\n");
-                    exit(1);
-                }
-                if (value != (uint64_t)(ram_addr_t)value) {
-                    fprintf(stderr, "qemu: ram size too large\n");
-                    exit(1);
-                }
-                ram_size = value;
-                break;
-            }
-            case QEMU_OPTION_d:
+            case QEMU_OPTION_m: 
                 {
-                    int mask;
-                    CPULogItem *item;
-
-                    mask = cpu_str_to_log_mask(optarg);
-                    if (!mask) {
-                        printf("Log items (comma separated):\n");
-                    for(item = cpu_log_items; item->mask != 0; item++) {
-                        printf("%-10s %s\n", item->name, item->help);
+                    uint64_t value;
+                    char *ptr;
+                    
+                    value = strtoul(optarg, &ptr, 0);
+                    switch (*ptr) {
+                    case 0: case 'M': case 'm':
+                        break;
+                    case 'G': case 'g':
+                        value <<= 10;
+                        break;
+                    default:
+                        fprintf(stderr, "qemu: invalid ram size: %s\n", optarg);
+                        exit(1);
                     }
-                    exit(1);
-                    }
-                    cpu_set_log(mask);
+                    qemu_device_set_int(machine_dev, "ramsize", value);
                 }
                 break;
+            case QEMU_OPTION_d:
+                qemu_device_set_str(machine_dev, "debug", optarg);
+                break;
 #ifdef CONFIG_GDBSTUB
             case QEMU_OPTION_s:
                 use_gdbstub = 1;
@@ -8072,176 +9120,149 @@
                 break;
 #endif
             case QEMU_OPTION_L:
-                bios_dir = optarg;
+                qemu_device_set_str(machine_dev, "bios_dir", optarg);
                 break;
             case QEMU_OPTION_bios:
-                bios_name = optarg;
+                qemu_device_set_str(machine_dev, "bios", optarg);
                 break;
             case QEMU_OPTION_S:
-                autostart = 0;
+                qemu_device_set_bool(machine_dev, "autostart", 0);
                 break;
 	    case QEMU_OPTION_k:
-		keyboard_layout = optarg;
+                qemu_device_set_str(qemu_prefs, "keyboard_layout", optarg);
 		break;
             case QEMU_OPTION_localtime:
-                rtc_utc = 0;
+                qemu_device_set_bool(machine_dev, "localtime", 1);
                 break;
             case QEMU_OPTION_cirrusvga:
-                cirrus_vga_enabled = 1;
-                vmsvga_enabled = 0;
+                qemu_device_set_str(machine_dev, "display", "cirrus");
                 break;
             case QEMU_OPTION_vmsvga:
-                cirrus_vga_enabled = 0;
-                vmsvga_enabled = 1;
+                qemu_device_set_str(machine_dev, "display", "vmsvga");
                 break;
             case QEMU_OPTION_std_vga:
-                cirrus_vga_enabled = 0;
-                vmsvga_enabled = 0;
+                qemu_device_set_str(machine_dev, "display", "vga");
                 break;
             case QEMU_OPTION_g:
+                qemu_device_set_str(machine_dev, "display_params", optarg);
+                break;
+            case QEMU_OPTION_echr:
                 {
-                    const char *p;
-                    int w, h, depth;
-                    p = optarg;
-                    w = strtol(p, (char **)&p, 10);
-                    if (w <= 0) {
-                    graphic_error:
-                        fprintf(stderr, "qemu: invalid resolution or depth\n");
+                    int val;
+                    char *r;
+                    val = strtol(optarg, &r, 0);
+                    if (*r != '\0') {
+                        fprintf(stderr, "Bad argument to echr\n");
                         exit(1);
                     }
-                    if (*p != 'x')
-                        goto graphic_error;
-                    p++;
-                    h = strtol(p, (char **)&p, 10);
-                    if (h <= 0)
-                        goto graphic_error;
-                    if (*p == 'x') {
-                        p++;
-                        depth = strtol(p, (char **)&p, 10);
-                        if (depth != 8 && depth != 15 && depth != 16 &&
-                            depth != 24 && depth != 32)
-                            goto graphic_error;
-                    } else if (*p == '\0') {
-                        depth = graphic_depth;
-                    } else {
-                        goto graphic_error;
-                    }
-
-                    graphic_width = w;
-                    graphic_height = h;
-                    graphic_depth = depth;
+                    qemu_device_set_int(machine_dev, "term_escape_char", val);
                 }
                 break;
-            case QEMU_OPTION_echr:
-                {
-                    char *r;
-                    term_escape_char = strtol(optarg, &r, 0);
-                    if (r == optarg)
-                        printf("Bad argument to echr\n");
-                    break;
-                }
             case QEMU_OPTION_monitor:
-                monitor_device = optarg;
+                qemu_device_set_str(machine_dev, "monitor", optarg);
                 break;
             case QEMU_OPTION_serial:
-                if (serial_device_index >= MAX_SERIAL_PORTS) {
-                    fprintf(stderr, "qemu: too many serial ports\n");
-                    exit(1);
+                {
+                    char buf[128];
+                    if (serial_device_index >= MAX_SERIAL_PORTS) {
+                        fprintf(stderr, "qemu: too many serial ports\n");
+                        exit(1);
+                    }
+                    snprintf(buf, sizeof(buf), "serial%d", 
+                             serial_device_index);
+                    qemu_device_set_str(machine_dev, buf, optarg);
+                    serial_device_index++;
                 }
-                serial_devices[serial_device_index] = optarg;
-                serial_device_index++;
                 break;
             case QEMU_OPTION_parallel:
-                if (parallel_device_index >= MAX_PARALLEL_PORTS) {
-                    fprintf(stderr, "qemu: too many parallel ports\n");
-                    exit(1);
+                {
+                    char buf[128];
+                    if (parallel_device_index >= MAX_PARALLEL_PORTS) {
+                        fprintf(stderr, "qemu: too many parallel ports\n");
+                        exit(1);
+                    }
+                    snprintf(buf, sizeof(buf), "parallel%d", 
+                             parallel_device_index);
+                    qemu_device_set_str(machine_dev, buf, optarg);
+                    parallel_device_index++;
                 }
-                parallel_devices[parallel_device_index] = optarg;
-                parallel_device_index++;
                 break;
 	    case QEMU_OPTION_loadvm:
-		loadvm = optarg;
+                qemu_device_set_str(machine_dev, "loadvm", optarg);
 		break;
             case QEMU_OPTION_full_screen:
-                full_screen = 1;
+                qemu_device_set_bool(qemu_prefs, "full_screen", 1);
                 break;
 #ifdef CONFIG_SDL
             case QEMU_OPTION_no_frame:
-                no_frame = 1;
+                qemu_device_set_bool(qemu_prefs, "sdl_no_frame", 1);
                 break;
             case QEMU_OPTION_alt_grab:
-                alt_grab = 1;
+                qemu_device_set_bool(qemu_prefs, "sdl_alt_grab", 1);
                 break;
             case QEMU_OPTION_no_quit:
-                no_quit = 1;
+                qemu_device_set_bool(qemu_prefs, "sdl_no_quit", 1);
                 break;
 #endif
             case QEMU_OPTION_pidfile:
-                pid_file = optarg;
+                qemu_device_set_str(qemu_prefs, "pidfile", optarg);
                 break;
 #ifdef TARGET_I386
             case QEMU_OPTION_win2k_hack:
-                win2k_install_hack = 1;
+                qemu_device_set_bool(machine_dev, "win2k_hack", 1);
                 break;
 #endif
 #ifdef USE_KQEMU
             case QEMU_OPTION_no_kqemu:
-                kqemu_allowed = 0;
+                qemu_device_set_str(machine_dev, "kqemu", "no");
                 break;
             case QEMU_OPTION_kernel_kqemu:
-                kqemu_allowed = 2;
+                qemu_device_set_str(machine_dev, "kqemu", "kernel");
                 break;
 #endif
             case QEMU_OPTION_usb:
-                usb_enabled = 1;
+                qemu_device_set_bool(machine_dev, "usb", 1);
                 break;
             case QEMU_OPTION_usbdevice:
-                usb_enabled = 1;
-                if (usb_devices_index >= MAX_USB_CMDLINE) {
-                    fprintf(stderr, "Too many USB devices\n");
-                    exit(1);
-                }
-                usb_devices[usb_devices_index] = optarg;
-                usb_devices_index++;
+                qemu_device_set_bool(machine_dev, "usb", 1);
+                usb_device_add_cmdline(optarg);
                 break;
             case QEMU_OPTION_smp:
-                smp_cpus = atoi(optarg);
-                if (smp_cpus < 1 || smp_cpus > MAX_CPUS) {
-                    fprintf(stderr, "Invalid number of CPUs\n");
-                    exit(1);
-                }
+                qemu_device_set_int(machine_dev, "smp", atoi(optarg));
                 break;
 	    case QEMU_OPTION_vnc:
-		vnc_display = optarg;
+                qemu_device_set_str(qemu_prefs, "ui", "vnc");
+                qemu_device_set_str(qemu_prefs, "vnc_params", optarg);
 		break;
             case QEMU_OPTION_no_acpi:
-                acpi_enabled = 0;
+                qemu_device_set_bool(machine_dev, "acpi", 0);
                 break;
             case QEMU_OPTION_no_reboot:
-                no_reboot = 1;
+                qemu_device_set_bool(machine_dev, "reboot", 0);
                 break;
             case QEMU_OPTION_no_shutdown:
-                no_shutdown = 1;
+                qemu_device_set_bool(machine_dev, "shutdown", 0);
                 break;
             case QEMU_OPTION_show_cursor:
-                cursor_hide = 0;
+                qemu_device_set_bool(qemu_prefs, "sdl_show_cursor", 1);
                 break;
 	    case QEMU_OPTION_daemonize:
-		daemonize = 1;
+                qemu_device_set_bool(qemu_prefs, "daemonize", 1);
 		break;
 	    case QEMU_OPTION_option_rom:
-		if (nb_option_roms >= MAX_OPTION_ROMS) {
-		    fprintf(stderr, "Too many option ROMs\n");
-		    exit(1);
-		}
-		option_rom[nb_option_roms] = optarg;
-		nb_option_roms++;
+                {
+                    char buf[128];
+                    snprintf(buf, sizeof(buf), "option_rom%d", 
+                             nb_option_roms);
+                    qemu_device_set_str(machine_dev, buf, optarg);
+                    nb_option_roms++;
+                }
 		break;
             case QEMU_OPTION_semihosting:
-                semihosting_enabled = 1;
+                qemu_device_set_bool(machine_dev, "semihosting", 1);
                 break;
             case QEMU_OPTION_name:
-                qemu_name = optarg;
+                qemu_device_set_str(machine_dev, "name", optarg);
                 break;
 #ifdef TARGET_SPARC
             case QEMU_OPTION_prom_env:
